package djmil.hellomvc;

import static org.hamcrest.Matchers.containsString;
import static org.mockito.Mockito.when;
import static org.springframework.test.web.servlet.request.MockMvcRequestBuilders.get;
import static org.springframework.test.web.servlet.result.MockMvcResultHandlers.print;
import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.content;
import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.status;

import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.autoconfigure.web.servlet.WebMvcTest;
import org.springframework.boot.test.mock.mockito.MockBean;
import org.springframework.test.web.servlet.MockMvc;

@WebMvcTest(GreetingController.class)
public class CreetingControllerTests {

	@Autowired
	private MockMvc mockMvc;

	@MockBean
	private GreetingService service;

	// @Test
	// public void shouldReturnDefaultMessage() throws Exception {
	// 	this.mockMvc.perform(get("/greeting"))
    //             .andDo(print())
    //             .andExpect(status().isOk())
	// 			.andExpect(content().string(containsString("Hello, World")));
	// }

	@Test
	public void greetingShouldReturnMessageFromService() throws Exception {
		when(service.nameLength("World")).thenReturn(7);
		this.mockMvc.perform(get("/greeting"))
				.andDo(print())
				.andExpect(status().isOk())
				.andExpect(content().string(containsString("Length of a given name is 7 characters.")));
	}
}